﻿using System;
using System.Collections.Generic;
using System.Collections.Immutable;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EntityFramework
{
    [Table("Champion")]
    public class ChampionEntity
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int Id { get; set; }

        [Required]
        [MaxLength(50)]
        public string Name { get; set; }

        
        [MaxLength(500)]
        [Column("Bio", TypeName = "string")]
        public string Bio { get; set; }

        [Required]
        public string Icon { get; set; }

        public ImmutableHashSet<Skill> Skills => skills.ToImmutableHashSet();
        private HashSet<Skill> skills = new HashSet<Skill>();

        public ChampionEntity(string name,string bio,string icon) {
            this.Name = name;
            this.Bio = bio;
            this.Icon = icon;
        }

        public override string ToString()
        {
            return Name;
        }



        public bool AddSkill(Skill skill)
            => skills.Add(skill);

        public bool RemoveSkill(Skill skill)
            => skills.Remove(skill);
    }
}
