﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EntityFramework
{
    public class Skill
    {
        public SkillType Type { get; private set; }

        public string Name
        {
            get => name;
            private init
            {
                if (string.IsNullOrWhiteSpace(value))
                {
                    throw new ArgumentException("a Skill needs a name");
                }
                name = value;
            }
        }
        private readonly string name = null!;

        public string Description
        {
            get => description;
            set
            {
                if (string.IsNullOrWhiteSpace(value))
                {
                    description = "";
                    return;
                }
                description = value;
            }
        }
        private string description = "";
    }
}
